<template>
  <v-snackbar :value="snack.show" :color="snack.color" top class="top-snackbar">
    <div class="message">
      <v-row dense>
        <v-col cols="auto">
          {{ snack.message }}
        </v-col>
        <v-spacer />
        <v-col cols="auto" v-if="!indeterminate">
          <v-icon @click="hideMessage">mdi-close</v-icon>
        </v-col>
      </v-row>
    </div>
    <v-progress-linear
      :indeterminate="indeterminate"
      value="100"
      :color="`${snack.color} darken-1`"
    />
  </v-snackbar>
</template>
<script lang="ts">
import { SnackState } from "@/store/modules/snack/types";
import { Component, Vue, Watch } from "vue-property-decorator";
import { Mutation, Getter } from "vuex-class";

@Component
export default class SnackBar extends Vue {
  @Getter("snack", { namespace: "snack" }) readonly snack!: SnackState;
  @Mutation("hideMessage", { namespace: "snack" }) hideMessage!: Function;

  timeout = 0;
  @Watch("snack.timeout")
  watchTimeout(value: number) {
    clearTimeout(this.timeout);
    if (value > 0) {
      this.timeout = setTimeout(() => {
        this.hideMessage();
      }, value);
    }
    return false;
  }

  get indeterminate() {
    return this.snack.timeout < 0;
  }
}
</script>
<style lang="scss">
.top-snackbar {
  .v-snack__content {
    .message {
      padding: 14px 16px;
    }
    padding: 0px;
  }
  .v-snack__action {
    margin-right: 0px !important;
  }
}
</style>
